<?php
/**
 * @brief randomPost, a plugin for Dotclear 2
 *
 * @package Dotclear
 * @subpackage Plugins
 *
 * @author julien mudry and contributors
 *
 * @copyright julien mudry
 * @copyright GPL-2.0 https://www.gnu.org/licenses/gpl-2.0.html
 */
if (!defined('DC_CONTEXT_ADMIN')) {
    return;
}

if (!dcCore::app()->newVersion(basename(__DIR__), dcCore::app()->plugins->moduleInfo(basename(__DIR__), 'version'))) {
    return;
}

function putRPostGlobalSetting($id, $value, $type=null, $label=null, $valueChange=true)
{
    $oldValue = dcCore::app()->blog->settings->randomPost->get($id);
    if ($oldValue === null) {
        dcCore::app()->blog->settings->randomPost->put($id, $value, $type, $label, $valueChange, true);
    } else {
        dcCore::app()->blog->settings->randomPost->put($id, $oldValue, $type, $label, $valueChange, true);
    }
}

try {
    // Insert below necessary initialisations and updates

    // Install default values for the settings if they don't exist yet
    dcCore::app()->blog->settings->addNamespace('randomPost');
    putRPostGlobalSetting('randomPostURL', 'random', 'string', 'Prefix for the URL redirecting to a random post');
    putRPostGlobalSetting('randomPostStaticURL', 'randomPost', 'string', 'Prefix for the URL displaying a random post');

    $old_version = dcCore::app()->getVersion(basename(__DIR__));
    if (version_compare((string) $old_version, '0.9.2', '<')) {
        ; // Update since 0.9.2 to be completed
    }

    return true;
} catch (Exception $e) {
    dcCore::app()->error->add($e->getMessage());
}

return false;
